public inbox for git-commits@fedoraproject.org
help / color / mirror / Atom feed
* [rpms/gcc] rhel-f41-base: CI gating: Switch to FMF format, include a beakerlib based smoke test coming from RHEL.
@ 2026-06-29 12:29 Martin Cermak
  0 siblings, 0 replies; only message in thread
From: Martin Cermak @ 2026-06-29 12:29 UTC (permalink / raw)
  To: git-commits

A new commit has been pushed.

Repo   : rpms/gcc
Branch : rhel-f41-base
Commit : 47dcf480fc5e7de9373e8c31ca2b1c0a34039ad2
Author : Martin Cermak <mcermak@redhat.com>
Date   : 2021-01-04T18:22:49+01:00
Stats  : +380/-33 in 19 file(s)
URL    : https://src.fedoraproject.org/rpms/gcc/c/47dcf480fc5e7de9373e8c31ca2b1c0a34039ad2?branch=rhel-f41-base

Log:
CI gating: Switch to FMF format, include a beakerlib based smoke test coming from RHEL.

---
diff --git a/.fmf/version b/.fmf/version
new file mode 100644
index 0000000..d00491f
--- /dev/null
+++ b/.fmf/version
@@ -0,0 +1 @@
+1

diff --git a/gating.yaml b/gating.yaml
new file mode 100644
index 0000000..c6030c9
--- /dev/null
+++ b/gating.yaml
@@ -0,0 +1,14 @@
+--- !Policy
+product_versions:
+  - fedora-*
+decision_context: bodhi_update_push_stable
+subject_type: koji_build
+rules:
+  - !PassingTestCaseRule {test_case_name: fedora-ci.koji-build.tier0.functional}
+--- !Policy
+product_versions:
+  - rhel-9
+decision_context: osci_compose_gate
+rules:
+  - !PassingTestCaseRule {test_case_name: baseos-ci.brew-build.tier1-gating.functional}
+  - !PassingTestCaseRule {test_case_name: baseos-ci.brew-build.tier1-gating-p9.functional}

diff --git a/plans/ci.fmf b/plans/ci.fmf
new file mode 100644
index 0000000..1ad2c12
--- /dev/null
+++ b/plans/ci.fmf
@@ -0,0 +1,6 @@
+summary: CI Gating Plan
+discover:
+    how: fmf
+    directory: tests
+execute:
+    how: beakerlib

diff --git a/tests/build_hello_world.sh b/tests/build_hello_world.sh
deleted file mode 100755
index f6aae70..0000000
--- a/tests/build_hello_world.sh
+++ /dev/null
@@ -1,9 +0,0 @@
-#!/bin/bash
-
-set -ex
-
-gcc -x c $(rpm --eval %build_cflags) data/hello.c -o hello_c.out
-./hello_c.out | grep -q "Hello World"
-
-g++ -x c++ $(rpm --eval %build_cxxflags) data/hello.cpp -o hello_cpp.out
-./hello_cpp.out | grep -q "Hello World"

diff --git a/tests/data/hello.c b/tests/data/hello.c
deleted file mode 100644
index fe064a2..0000000
--- a/tests/data/hello.c
+++ /dev/null
@@ -1,5 +0,0 @@
-#include <stdio.h>
-int main() {
-	printf("Hello World!\n");
-	return 0;
-}

diff --git a/tests/data/hello.cpp b/tests/data/hello.cpp
deleted file mode 100644
index 2131d8a..0000000
--- a/tests/data/hello.cpp
+++ /dev/null
@@ -1,5 +0,0 @@
-#include <iostream>
-int main() {
-	std::cout << "Hello World!\n";
-	return 0;
-}

diff --git a/tests/smoke-test/Makefile b/tests/smoke-test/Makefile
new file mode 100644
index 0000000..fb46790
--- /dev/null
+++ b/tests/smoke-test/Makefile
@@ -0,0 +1,65 @@
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   Makefile of /tools/gcc/Sanity/smoke-test
+#   Description: Basic smoke test.
+#   Author: Marek Polacek <polacek@redhat.com>
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   Copyright (c) 2012 Red Hat, Inc. All rights reserved.
+#
+#   This copyrighted material is made available to anyone wishing
+#   to use, modify, copy, or redistribute it subject to the terms
+#   and conditions of the GNU General Public License version 2.
+#
+#   This program is distributed in the hope that it will be
+#   useful, but WITHOUT ANY WARRANTY; without even the implied
+#   warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#   PURPOSE. See the GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public
+#   License along with this program; if not, write to the Free
+#   Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+#   Boston, MA 02110-1301, USA.
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+export TEST=/tools/gcc/Sanity/smoke-test
+export TESTVERSION=1.0
+
+BUILT_FILES=
+
+FILES=$(METADATA) runtest.sh Makefile PURPOSE hello.c hello.f90 hello.cpp tm.c quad.c omphello.c thr-init-2.c clear_cache.c
+
+.PHONY: all install download clean
+
+run: $(FILES) build
+	./runtest.sh
+
+build: $(BUILT_FILES)
+	test -x runtest.sh || chmod a+x runtest.sh
+
+clean:
+	rm -f *~ $(BUILT_FILES)
+
+
+include /usr/share/rhts/lib/rhts-make.include
+
+$(METADATA): Makefile
+	@echo "Owner:           Marek Polacek <mpolacek@redhat.com>" > $(METADATA)
+	@echo "Name:            $(TEST)" >> $(METADATA)
+	@echo "TestVersion:     $(TESTVERSION)" >> $(METADATA)
+	@echo "Path:            $(TEST_DIR)" >> $(METADATA)
+	@echo "Description:     Basic smoke test." >> $(METADATA)
+	@echo "Type:            Sanity" >> $(METADATA)
+	@echo "TestTime:        10m" >> $(METADATA)
+	@echo "RunFor:          gcc" >> $(METADATA)
+	@echo "RunFor:          devtoolset-1.0-gcc" >> $(METADATA)
+	@echo "Requires:        gcc gcc-c++ gcc-gfortran glibc-common glibc-devel" >> $(METADATA)
+	@echo "Requires:        libquadmath libquadmath-devel libgomp libgcc libstdc++-devel" >> $(METADATA)
+	@echo "Priority:        Normal" >> $(METADATA)
+	@echo "License:         GPLv2" >> $(METADATA)
+	@echo "Confidential:    no" >> $(METADATA)
+	@echo "Destructive:     no" >> $(METADATA)
+
+	rhts-lint $(METADATA)

diff --git a/tests/smoke-test/PURPOSE b/tests/smoke-test/PURPOSE
new file mode 100644
index 0000000..912f7b4
--- /dev/null
+++ b/tests/smoke-test/PURPOSE
@@ -0,0 +1,3 @@
+PURPOSE of /tools/gcc/Sanity/smoke-test
+Description: Basic smoke test.
+Author: Marek Polacek <polacek@redhat.com>

diff --git a/tests/smoke-test/clear_cache.c b/tests/smoke-test/clear_cache.c
new file mode 100644
index 0000000..b10479f
--- /dev/null
+++ b/tests/smoke-test/clear_cache.c
@@ -0,0 +1,7 @@
+int
+main (void)
+{
+  char *mem = __builtin_alloca (40);
+  __builtin___clear_cache (mem, mem + 40);
+  return 0;
+}

diff --git a/tests/smoke-test/hello.c b/tests/smoke-test/hello.c
new file mode 100644
index 0000000..4096e11
--- /dev/null
+++ b/tests/smoke-test/hello.c
@@ -0,0 +1,7 @@
+#include <stdio.h>
+
+int
+main (void)
+{
+  puts ("Hello World!");
+}

diff --git a/tests/smoke-test/hello.cpp b/tests/smoke-test/hello.cpp
new file mode 100644
index 0000000..0f2234e
--- /dev/null
+++ b/tests/smoke-test/hello.cpp
@@ -0,0 +1,7 @@
+#include <iostream>
+
+int
+main (void)
+{
+ std::cout << "Hello, world!\n";
+}

diff --git a/tests/smoke-test/hello.f90 b/tests/smoke-test/hello.f90
new file mode 100644
index 0000000..afabbb2
--- /dev/null
+++ b/tests/smoke-test/hello.f90
@@ -0,0 +1,3 @@
+       program hello
+          print *, "Hello World!"
+       end program hello

diff --git a/tests/smoke-test/main.fmf b/tests/smoke-test/main.fmf
new file mode 100644
index 0000000..3710ca3
--- /dev/null
+++ b/tests/smoke-test/main.fmf
@@ -0,0 +1,22 @@
+summary: Basic smoke test.
+description: ''
+contact:
+- Marek Polacek <mpolacek@redhat.com>
+component:
+- gcc
+test: ./runtest.sh
+framework: beakerlib
+recommend:
+- gcc
+- gcc-c++
+- gcc-gfortran
+- glibc-common
+- glibc-devel
+- libquadmath
+- libquadmath-devel
+- libgomp
+- libgcc
+- libstdc++-devel
+duration: 10m
+extra-summary: /tools/gcc/Sanity/smoke-test
+extra-task: /tools/gcc/Sanity/smoke-test

diff --git a/tests/smoke-test/omphello.c b/tests/smoke-test/omphello.c
new file mode 100644
index 0000000..85b591f
--- /dev/null
+++ b/tests/smoke-test/omphello.c
@@ -0,0 +1,24 @@
+#include <omp.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+int
+main (void)
+{
+  int th_id;
+  int nthreads;
+
+  #pragma omp parallel private(th_id)
+  {
+    th_id = omp_get_thread_num ();
+    printf ("Hello World from thread %d\n", th_id);
+
+    #pragma omp barrier
+    if (th_id == 0)
+      {
+	nthreads = omp_get_num_threads ();
+	printf ("There are %d threads\n", nthreads);
+      }
+  }
+  return EXIT_SUCCESS;
+}

diff --git a/tests/smoke-test/quad.c b/tests/smoke-test/quad.c
new file mode 100644
index 0000000..e5a6cc7
--- /dev/null
+++ b/tests/smoke-test/quad.c
@@ -0,0 +1,38 @@
+#include <quadmath.h>
+#include <stdlib.h>
+#include <stdio.h>
+
+int
+main (void)
+{
+  __float128 r = strtoflt128 ("1.23456789", NULL);
+
+  int prec = 20;
+  int width = 46;
+  char buf[128];
+
+  r = 2.0q;
+  r = sqrtq (r);
+  int n = quadmath_snprintf (buf, sizeof buf, "%+-#*.20Qe", width, r);
+  if ((size_t) n < sizeof buf)
+    /* Prints: +1.41421356237309504880e+00 */
+    printf ("%s\n", buf);
+  quadmath_snprintf (buf, sizeof buf, "%Qa", r);
+  if ((size_t) n < sizeof buf)
+    /* Prints: 0x1.6a09e667f3bcc908b2fb1366ea96p+0 */
+    printf ("%s\n", buf);
+  n = quadmath_snprintf (NULL, 0, "%+-#46.*Qe", prec, r);
+  if (n > -1)
+    {
+      char *str = malloc (n + 1);
+      if (str)
+	{
+	  quadmath_snprintf (str, n + 1, "%+-#46.*Qe", prec, r);
+	  /* Prints: +1.41421356237309504880e+00 */
+	  printf ("%s\n", str);
+        }
+      free (str);
+    }
+
+  return 0;
+}

diff --git a/tests/smoke-test/runtest.sh b/tests/smoke-test/runtest.sh
new file mode 100755
index 0000000..78fda72
--- /dev/null
+++ b/tests/smoke-test/runtest.sh
@@ -0,0 +1,125 @@
+#!/bin/bash
+# vim: dict=/usr/share/beakerlib/dictionary.vim cpt=.,w,b,u,t,i,k
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   runtest.sh of /tools/gcc/Sanity/smoke-test
+#   Description: Basic smoke test.
+#   Author: Marek Polacek <polacek@redhat.com>
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   Copyright (c) 2012 Red Hat, Inc. All rights reserved.
+#
+#   This copyrighted material is made available to anyone wishing
+#   to use, modify, copy, or redistribute it subject to the terms
+#   and conditions of the GNU General Public License version 2.
+#
+#   This program is distributed in the hope that it will be
+#   useful, but WITHOUT ANY WARRANTY; without even the implied
+#   warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#   PURPOSE. See the GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public
+#   License along with this program; if not, write to the Free
+#   Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+#   Boston, MA 02110-1301, USA.
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+# Include Beaker environment
+. /usr/share/beakerlib/beakerlib.sh || exit 1
+
+PACKAGES=(gcc gcc-c++ gcc-gfortran glibc-common libgomp libgcc glibc-devel libstdc++ libstdc++-devel)
+
+# Choose the compiler.
+GCC=${GCC:-gcc}
+GXX=${GXX:-g++}
+GFORTRAN=${GFORTRAN:-gfortran}
+
+PACKAGE=gcc
+
+rlJournalStart
+  rlPhaseStartSetup
+    export PRI_ARCH=`rlGetPrimaryArch`
+    export SEC_ARCH=`rlGetSecondaryArch`
+    # don't assert anything under devtoolset
+    if type gcc | grep -q -v devtoolset
+    then
+      for p in "${PACKAGES[@]}"; do
+        rpm -q "$p.$PRI_ARCH" || yum install -y "$p.$PRI_ARCH"
+        rlAssertRpm "$p.$PRI_ARCH"
+      done; unset p
+    fi
+    rlLog "GCC = $GCC"
+    rlLog "Installed within `rpmquery -f $(which $GCC)`"
+    rlLog "GXX = $GXX"
+    rlLog "Installed within `rpmquery -f $(which $GXX)`"
+    rlLog "GFORTRAN = $GFORTRAN"
+    rlLog "Installed within `rpmquery -f $(which $GFORTRAN)`"
+    rlRun "TmpDir=\$(mktemp -d)" 0 "Creating tmp directory"
+    # We need some files.
+    rlRun "cp -v hello.{c,cpp,f90} tm.c quad.c thr-init-2.c clear_cache.c omphello.c $TmpDir"
+    rlRun "pushd $TmpDir"
+    rlRun "rpmquery -l libstdc++-devel.$PRI_ARCH"
+    test -n "$SEC_ARCH" && rpmquery "libstdc++-devel.$SEC_ARCH" && rlRun "rpmquery -l libstdc++-devel.$SEC_ARCH"
+  rlPhaseEnd
+
+  rlPhaseStartSetup "Showing compiler versions"
+    for compiler in $GCC $GXX $GFORTRAN
+    do
+      rlLog "Version of compiler: $compiler"
+      eval "$compiler --version 2>&1" | while read line
+      do
+        rlLog "  $line"
+      done
+    done
+  rlPhaseEnd
+
+  rlPhaseStartTest "Compile"
+    rlRun "$GCC hello.c -o hello_c"
+    rlRun "$GXX hello.cpp -o hello_cpp"
+    rlRun "$GFORTRAN hello.f90 -o hello_fortran"
+
+    # TM support is GCC >=4.7 only.
+    $GCC -xc -O2 -std=gnu99 -fgnu-tm - <<< "int main(){}"
+    if test $? -eq 0; then
+      rlRun "$GCC -O2 -std=gnu99 -fgnu-tm tm.c -o tm"
+      rlRun "./tm"
+    fi
+
+    # Test OpenMP.
+    rlRun "$GCC omphello.c -O2 -std=gnu99 -fopenmp -o omp"
+    rlRun "./omp"
+
+    # Test __thread.
+    rlRun "$GCC thr-init-2.c -O2 -std=gnu99 -ftls-model=initial-exec -o thr" 
+    rlRun "./thr"
+
+    # Now test some libquadmath stuff (__float128 support).
+    # libquadmath is mising on RHEL machines, usually.
+    test "`rpmquery --qf '%{version}-%{release}' libquadmath`" = "`rpmquery --qf '%{version}-%{release}' $GCC`"
+    if test $? -eq 0 -a "$GCC" = "gcc"; then
+      rlRun "$GCC quad.c -O2 -std=gnu99 -lquadmath -lm -o quad"
+      rlRun "./quad"
+    fi
+
+    # And now something from libgcc, e.g. __builtin___clear_cache.
+    # But not on RHEL5.
+    if ! rlIsRHEL 5; then
+      rlRun "$GCC clear_cache.c -O2 -std=gnu99 -o cache"
+	  rlRun "./cache"
+    fi
+  rlPhaseEnd
+
+  rlPhaseStartTest "Check dependant libraries"
+    rlRun "ldd hello_{c,cpp,fortran} &> ldd.out"
+    # Nothing should be linked against anything in /opt.
+    rlAssertNotGrep "/opt" ldd.out
+  rlPhaseEnd
+
+  rlPhaseStartCleanup
+    rlRun "popd"
+    rlRun "rm -r $TmpDir" 0 "Removing tmp directory"
+  rlPhaseEnd
+rlJournalPrintText
+rlJournalEnd

diff --git a/tests/smoke-test/thr-init-2.c b/tests/smoke-test/thr-init-2.c
new file mode 100644
index 0000000..051cff9
--- /dev/null
+++ b/tests/smoke-test/thr-init-2.c
@@ -0,0 +1,24 @@
+/* { dg-do run } */
+/* { dg-require-effective-target tls_runtime } */
+/* { dg-add-options tls } */
+
+extern void abort() ;
+
+static __thread int fstat ;
+static __thread int fstat = 1;
+
+int test_code(int b)
+{
+  fstat += b ;
+  return fstat;
+}
+
+int main (int ac, char *av[])
+{
+  int a = test_code(1);
+
+  if ((a != 2) || (fstat != 2))
+    abort () ;
+
+  return 0;
+}

diff --git a/tests/smoke-test/tm.c b/tests/smoke-test/tm.c
new file mode 100644
index 0000000..f9b4c9b
--- /dev/null
+++ b/tests/smoke-test/tm.c
@@ -0,0 +1,34 @@
+extern void *malloc (__SIZE_TYPE__) __attribute__((malloc,transaction_safe));
+
+static int __attribute__((transaction_safe))
+something (void)
+{
+  return 0;
+}
+
+struct large { int foo[500]; };
+
+int
+main (void)
+{
+  int *p;
+  struct large *lp;
+
+  __transaction_atomic {
+    p = malloc (sizeof (*p) * 100);
+    lp = malloc (sizeof (*lp) * 100);
+
+    /* No instrumentation necessary; P and LP are transaction local.  */
+    p[5] = 123;
+    lp->foo[66] = 123;
+
+    if (something ())
+      __transaction_cancel;
+  }
+
+  __transaction_relaxed {
+    ++p[5];
+  }
+
+  return ( (p[5] == 124) ? 0 : 1 );
+}

diff --git a/tests/tests.yml b/tests/tests.yml
deleted file mode 100644
index dfe09e0..0000000
--- a/tests/tests.yml
+++ /dev/null
@@ -1,14 +0,0 @@
-- hosts: localhost
-  roles:
-    - role: standard-test-basic                         
-      tags:
-        - classic
-      
-      required_packages:
-        - redhat-rpm-config
-        - annobin
-
-      tests:
-        - build_hello_world:
-            dir: .
-            run: "./build_hello_world.sh" 

^ permalink raw reply related	[flat|nested] only message in thread

only message in thread, other threads:[~2026-06-29 12:29 UTC | newest]

Thread overview: (only message) (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2026-06-29 12:29 [rpms/gcc] rhel-f41-base: CI gating: Switch to FMF format, include a beakerlib based smoke test coming from RHEL Martin Cermak

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox